## dde-shell 2.0.15

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

CMAKE_MINIMUM_REQUIRED(VERSION 3.16)

set(DS_VERSION "1.99.0" CACHE STRING "Define project version")
project(DDEShell
    VERSION "${DS_VERSION}"
    DESCRIPTION "dde-shell"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-shell"
    LANGUAGES CXX C
)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
option(BUILD_WITH_X11 "Build X11 emulation" ON)

set(DS_BUILD_WITH_QT6 ON CACHE BOOL "Build dde-shell with Qt6")

if (DS_BUILD_WITH_QT6)
    set(QT_VERSION_MAJOR 6)
    set(DTK_VERSION_MAJOR 6)
else()
    set(QT_VERSION_MAJOR 5)
    set(DTK_VERSION_MAJOR "")
endif()

include(CTest)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE STRING "Library install path")
set(DDE_SHELL_PACKAGE_INSTALL_DIR ${CMAKE_INSTALL_DATADIR}/dde-shell CACHE STRING "Package install path")
set(DDE_SHELL_PLUGIN_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/dde-shell CACHE STRING "Plugin install path")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dde-shell" CACHE STRING "Headers install path")
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/DDEShell" CACHE STRING "CMake config file install directory")
set(QML_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml" CACHE STRING "Qml plugin install directory")
set(DDE_SHELL_TRANSLATION_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/dde-shell" CACHE STRING "Translation install directory")

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH};${PROJECT_SOURCE_DIR}/cmake")
include(DDEShellPackageMacros)
include(KDEClangFormat)
include(KDEGitCommitHooks)

find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Concurrent Quick WaylandClient WaylandCompositor DBus LinguistTools Sql)
if(Qt${QT_VERSION_MAJOR}_VERSION VERSION_GREATER_EQUAL 6.10)
  find_package(Qt${QT_VERSION_MAJOR} COMPONENTS WaylandClientPrivate WaylandCompositorPrivate REQUIRED)
endif()
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui)
find_package(ICU 74.2 REQUIRED COMPONENTS uc i18n io)
find_package(WaylandProtocols REQUIRED)
find_package(PkgConfig REQUIRED)

qt_policy(SET QTP0001 NEW)

try_compile(COMPILE_RESULT
    ${CMAKE_CURRENT_BINARY_DIR}/try_compile_build
    SOURCES ${CMAKE_SOURCE_DIR}/tests/check/qt_wayland_keyextension.cpp
    LINK_LIBRARIES
        Qt${QT_VERSION_MAJOR}::WaylandCompositorPrivate
        Qt${QT_VERSION_MAJOR}::WaylandCompositor
    COMPILE_DEFINITIONS 
        -DQT_WAYLANDCOMPOSITOR_LIB
        -DQT_WAYLANDCOMPOSITORPRIVATE_LIB
        -DQT_WAYLANDCOMPOSITOR_IMPLEMENTATION
    OUTPUT_VARIABLE compile_output
)

if(COMPILE_RESULT)
    message(STATUS "Deepin Qt detected (try_compile success)")
    add_definitions(-DUSE_DEEPIN_QT)
else()
    message(STATUS "Deepin Qt not detected")
endif()

add_subdirectory(frame)
add_subdirectory(shell)
add_subdirectory(example)
add_subdirectory(panels)
add_subdirectory(applets)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif(BUILD_TESTING)

configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/DDEShellConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfig.cmake"
    INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfigVersion.cmake"
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)
# Install cmake config file
install(FILES "${PROJECT_SOURCE_DIR}/cmake/DDEShellPackageMacros.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfig.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfigVersion.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")

# add clang-format target for all our real source files
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== applets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_subdirectory(dde-am)
add_subdirectory(dde-appearance)
add_subdirectory(dde-apps)
add_subdirectory(dde-shutdown)

=== example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Quick)

add_subdirectory(applet-example)
add_subdirectory(applet-widget-example)
add_subdirectory(applet-example-data)
add_subdirectory(containment-example)
add_subdirectory(panel-example)
add_subdirectory(layershell-example)
add_subdirectory(osd-example)
add_subdirectory(drag-example)
add_subdirectory(lockscreen-example)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(bridge-example)
endif()

=== frame/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0
set(PUBLIC_HEADERS
    dsglobal.h
    dstypes.h
    pluginmetadata.h
    pluginloader.h
    pluginfactory.h
    applet.h
    appletdata.h
    containment.h
    panel.h
    appletproxy.h
    appletbridge.h
    qmlengine.h
    layershell/dlayershellwindow.h
    models/listtotableproxymodel.h
    dsutility.h
)

set(PRIVATE_HEADERS
    private/applet_p.h
    private/containment_p.h
    private/panel_p.h
    private/appletitem_p.h
    private/appletproxy_p.h
    private/appletbridge_p.h
    private/dsqmlglobal_p.h
    layershell/qwaylandlayershellsurface_p.h
    layershell/qwaylandlayershellintegration_p.h
    models/kextracolumnsproxymodel.h
    quick/dsquickdrag_p.h
)
set(PRIVATE_SOURCES "")
if (BUILD_WITH_X11)
    list(APPEND PRIVATE_HEADERS
        private/utility_x11_p.h
    )
    list(APPEND PRIVATE_SOURCES
        utility_x11.cpp
    )
endif(BUILD_WITH_X11)

add_library(dde-shell-frame SHARED
    ${PUBLIC_HEADERS}
    ${PRIVATE_HEADERS}
    ${PRIVATE_SOURCES}
    appletitem.h
    containmentitem.h
    dstypes.cpp
    appletdata.cpp
    pluginmetadata.cpp
    pluginloader.cpp
    pluginfactory.cpp
    applet.cpp
    containment.cpp
    panel.cpp
    appletproxy.cpp
    appletbridge.cpp
    appletitem.cpp
    containmentitem.cpp
    qmlengine.cpp
    appletitemmodel.h
    appletitemmodel.cpp
    dsqmlglobal.cpp
    layershell/dlayershellwindow.cpp
    layershell/qwaylandlayershellsurface.cpp
    layershell/qwaylandlayershellintegration.cpp
    models/kextracolumnsproxymodel.cpp
    models/listtotableproxymodel.cpp
    quick/dsquickdrag.cpp
    popupwindow.h
    popupwindow.cpp
    ddeshell_qml.qrc
    dsutility.cpp
)

set_target_properties(dde-shell-frame PROPERTIES
    PUBLIC_HEADER "${PUBLIC_HEADERS}"
)

qt_generate_wayland_protocol_client_sources(dde-shell-frame FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/layershell/protocol/wlr-layer-shell-unstable-v1.xml
    ${WaylandProtocols_DATADIR}/stable/xdg-shell/xdg-shell.xml
)

set_target_properties(dde-shell-frame PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION 1
    OUTPUT_NAME dde-shell
    EXPORT_NAME Shell
)

target_link_libraries(dde-shell-frame
PUBLIC
    Dtk${DTK_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Quick
PRIVATE
    Qt${QT_VERSION_MAJOR}::QuickPrivate
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
)
target_include_directories(dde-shell-frame INTERFACE
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)
target_link_directories(dde-shell-frame INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${LIB_INSTALL_DIR}>
)

if (BUILD_WITH_X11)
    target_compile_definitions(dde-shell-frame PRIVATE BUILD_WITH_X11)
    pkg_check_modules(XCB REQUIRED IMPORTED_TARGET xcb-ewmh xtst x11)
    target_sources(dde-shell-frame PRIVATE layershell/x11dlayershellemulation.h layershell/x11dlayershellemulation.cpp)
    target_link_libraries(dde-shell-frame PRIVATE PkgConfig::XCB)
endif(BUILD_WITH_X11)

target_compile_definitions(dde-shell-frame
INTERFACE
    DDE_SHELL_PACKAGE_PATH_SUBPATH="dde-shell"
PRIVATE
    DDE_SHELL_QML_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}/${QML_INSTALL_DIR}"
    DDE_SHELL_PLUGIN_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}/${DDE_SHELL_PLUGIN_INSTALL_DIR}"
    DS_LIB
)

install(TARGETS dde-shell-frame EXPORT DDEShellTargets DESTINATION "${LIB_INSTALL_DIR}" PUBLIC_HEADER DESTINATION "${INCLUDE_INSTALL_DIR}")
install(EXPORT DDEShellTargets NAMESPACE Dde:: FILE DDEShellTargets.cmake DESTINATION "${CONFIG_INSTALL_DIR}")

add_subdirectory(plugin)

=== panels/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_subdirectory(dock)
add_subdirectory(notification)

=== applets/dde-shutdown/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later
find_package(TreelandProtocols REQUIRED)

add_library(dde-shutdown SHARED
    shutdownapplet.cpp
    shutdownapplet.h
    treelandlockscreen.h
    treelandlockscreen.cpp
)

qt_generate_wayland_protocol_client_sources(dde-shutdown
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
)

target_link_libraries(dde-shutdown PRIVATE
    dde-shell-frame
    Qt${QT_MAJOR_VERSION}::DBus
    Qt${QT_VERSION_MAJOR}::WaylandClient
)

ds_install_package(PACKAGE org.deepin.ds.dde-shutdown TARGET dde-shutdown)

=== example/containment-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(ds-example-containment SHARED
    examplecontainment.h
    examplecontainment.cpp
)

target_link_libraries(ds-example-containment PRIVATE
    dde-shell-frame
)

ds_install_package(PACKAGE org.deepin.ds.example.containment TARGET ds-example-containment)

=== example/osd-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(ds-osd-example SHARED
    osdapplet.h
    osdapplet.cpp
)

target_link_libraries(ds-osd-example PRIVATE
    dde-shell-frame
)

ds_install_package(PACKAGE org.deepin.ds.example.osd TARGET ds-osd-example)

=== frame/plugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(URI "org.deepin.ds")
add_library(dde-shell-plugin SHARED
    qmlplugin.h
    qmlplugin.cpp
    qmldir
)

target_link_libraries(dde-shell-plugin
PUBLIC
    dde-shell-frame
PRIVATE
    Qt${QT_VERSION_MAJOR}::QuickPrivate
)

string(REPLACE "." "/" URI_PATH ${URI})
set_target_properties(dde-shell-plugin PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins/${URI_PATH}"
    OUTPUT_NAME dde-shell-plugin
)
set(QML_IMPORT_PATH "${PROJECT_BINARY_DIR}/plugins" CACHE STRING "Qt Creator extra qml import paths")
add_custom_command(TARGET dde-shell-plugin
POST_BUILD
   COMMAND ${CMAKE_COMMAND} -E  copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/qmldir" "${PROJECT_BINARY_DIR}/plugins/${URI_PATH}"    #out-file
)

install(TARGETS dde-shell-plugin EXPORT DDEShellTargets DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}")
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/qmldir DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/")

=== tests/panels/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

add_subdirectory(dock)

=== panels/dock/appruntimeitem/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

if (BUILD_WITH_X11)
pkg_check_modules(AppRunTimeXcb REQUIRED IMPORTED_TARGET xcb xcb-res xcb-ewmh xcb-icccm)

add_library(dock-appruntimeitem SHARED
    appruntimeitem.cpp
    appruntimeitem.h
    windowmanager.cpp
    windowmanager.h
    xcbgetinfo.h
    xcbgetinfo.cpp
    qmlappruntime.qrc
    ${CMAKE_SOURCE_DIR}/panels/dock/dockiteminfo.cpp
    ${CMAKE_SOURCE_DIR}/panels/dock/dockiteminfo.h
    ${CMAKE_SOURCE_DIR}/panels/dock/constants.h
    ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager/x11utils.h
    ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager/x11utils.cpp
    ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager/abstractwindow.h
    ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager/x11window.h
    ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager/x11window.cpp
)

target_include_directories(dock-appruntimeitem PRIVATE
     ${CMAKE_SOURCE_DIR}/panels/dock
     ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager
    "${CMAKE_CURRENT_BINARY_DIR}/../"
)
target_link_libraries(dock-appruntimeitem PRIVATE
    dde-shell-frame
    PkgConfig::AppRunTimeXcb
)

ds_install_package(PACKAGE org.deepin.ds.dock.appruntimeitem TARGET dock-appruntimeitem)
ds_handle_package_translation(PACKAGE org.deepin.ds.dock.appruntimeitem)

install(FILES "package/icons/appruntime.svg" DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dde-dock/icons/dcc-setting)
endif(BUILD_WITH_X11)

=== panels/dock/taskmanager/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS DBus WaylandClient)
find_package(yaml-cpp REQUIRED)
find_package(TreelandProtocols REQUIRED)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.Application.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME Application
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME ApplicationManager
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ObjectManager1.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME ObjectManager
)

qt_add_dbus_interfaces(
    DBUS_INTERFACES
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.Application.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ObjectManager1.xml
)

qt_add_dbus_adaptor(DBUS_INTERFACES
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.ds.dock.taskmanager.item.xml
    appitem.h
    dock::AbstractItem
    itemadaptor
    ItemAdaptor
)

qt_add_dbus_adaptor(DBUS_INTERFACES
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.ds.dock.taskmanager.xml
    taskmanager.h
    dock::TaskManager
    taskmanageradaptor
    TaskManagerAdaptor
)

add_library(dock-taskmanager SHARED ${DBUS_INTERFACES}
    abstractwindow.h
    abstractwindowmonitor.cpp
    abstractwindowmonitor.h
    abstractitem.h
    abstractitem.cpp
    appitem.cpp
    appitem.h
    rolecombinemodel.cpp
    rolecombinemodel.h
    rolegroupmodel.cpp
    rolegroupmodel.h
    itemmodel.cpp
    itemmodel.h
    desktopfileabstractparser.cpp
    desktopfileabstractparser.h
    desktopfileamparser.cpp
    desktopfileamparser.h
    desktopfileparserfactory.h
    dockcombinemodel.cpp
    dockcombinemodel.h
    dockitemmodel.cpp
    dockitemmodel.h
    dockglobalelementmodel.cpp
    dockglobalelementmodel.h
    dockgroupmodel.cpp
    dockgroupmodel.h
    hoverpreviewproxymodel.cpp
    hoverpreviewproxymodel.h
    taskmanager.cpp
    taskmanager.h
    treelandwindow.cpp
    treelandwindow.h
    treelandwindowmonitor.cpp
    treelandwindowmonitor.h
    taskmanagersettings.cpp
    taskmanagersettings.h
)

qt_generate_wayland_protocol_client_sources(dock-taskmanager
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-foreign-toplevel-manager-v1.xml
        ${WaylandProtocols_DATADIR}/staging/ext-foreign-toplevel-list/ext-foreign-toplevel-list-v1.xml
)

target_link_libraries(dock-taskmanager PRIVATE
    dde-shell-frame
    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
    Qt${QT_VERSION_MAJOR}::Concurrent
    yaml-cpp
    PkgConfig::WaylandClient
)

if (BUILD_WITH_X11)
    target_compile_definitions(dock-taskmanager PRIVATE BUILD_WITH_X11=)
    pkg_check_modules(TaskmanagerXcb REQUIRED IMPORTED_TARGET xcb xcb-res xcb-ewmh xcb-icccm)
    find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget)
    target_sources(dock-taskmanager PRIVATE
        x11preview.h
        x11preview.cpp
        x11preview.qrc
        x11utils.cpp
        x11utils.h
        x11window.cpp
        x11window.h
        x11windowmonitor.cpp
        x11windowmonitor.h
    )

    target_link_libraries(dock-taskmanager PUBLIC
        PkgConfig::TaskmanagerXcb
        Qt${QT_VERSION_MAJOR}::Widgets
        Dtk${DTK_VERSION_MAJOR}::Widget
    )
endif(BUILD_WITH_X11)

ds_install_package(PACKAGE org.deepin.ds.dock.taskmanager TARGET dock-taskmanager)
dtk_add_config_meta_files(APPID org.deepin.ds.dock FILES dconfig/org.deepin.ds.dock.taskmanager.json) # compat
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES dconfig/org.deepin.ds.dock.taskmanager.json)
ds_handle_package_translation(PACKAGE org.deepin.ds.dock.taskmanager)

=== debian/changelog ===
dde-shell (2.0.15) unstable; urgency=medium

  * fix: add missing definitions for dockpanel
  * feat: add notification auto cleanup and timeout handling
  * fix: Signals during the process of adding dock animations
  * fix: move tooltip text assignment to show handler
  * fix: improve OSD panel timeout behavior with modifier key
  * i18n: Updates for project Deepin Desktop Environment (#1304)
  * fix: sometimes clicking dock icon won't activate window as intended

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 23 Oct 2025 15:59:54 +0800

dde-shell (2.0.14) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#1294)
  * fix: icon minimize animation location on treeland is incorrect
  * fix: activate changed can cause crash
  * fix: compatibility with Qt 6.10
  * fix: align notification body text to top
  * fix: use rootObject to access dockSize property
  * fix: change text wrap mode from WordWrap to Wrap
  * chore: rename dock network plugin (#1296)

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 16 Oct 2025 21:13:36 +0800

dde-shell (2.0.13) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#1283)
  * feat: add delayed window state reset with singleShot
  * fix: show tray action icons during drag operations
  * feat: enhance trash functionality with file count and drag hints
  * fix: prevent time text flickering on hover
  * fix: Ensure the show desktop line is always 1 physical pixel
    regardless of system scaling
  * feat: add clean all button to notification center
  * feat: implement close all windows functionality
  * chore: update window icon geometry via new taskmanager interface
  * feat: add sorting to tray items
  * fix: The newly dragged in stash container item is not displayed at
    the back (#1280)
  * i18n: Updates for project Deepin Desktop Environment (#1276)

 -- YeShanShan <yeshanshan@uniontech.com>  Fri, 10 Oct 2025 17:32:04 +0800

dde-shell (2.0.12) unstable; urgency=medium

  * fix: prevent dragging items to fixed plugin section
  * feat: add clean all button for overlap notifications
  * fix: improve text visibility logic in AnimationSettingButton
  * fix: Popup windows was not closed  when dock screen changed (#1274)
  * fix: Application tray button can accept right mouse button to open
    popup window
  * fix: ensure preview icon will use icon from theme as fallback
  * fix: taskmanager context menu should use app name instead of window
    title
  * i18n: Updates for project Deepin Desktop Environment (#1266)
  * fix: adjust notification center window positioning
  * feat: add button text labels for accessibility

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 25 Sep 2025 17:40:29 +0800

dde-shell (2.0.11) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#1257)
  * fix: sometimes dock might be empty after boot and login
  * fix: improve notification close button hover detection
  * fix: desktop menu actions shows English instead of locale language
  * fix: fix notification center tab key focus issue
  * fix: missing attention role for taskmanager's base model
  * chore: Use the hasBlurWindow interface
  * fix: The tray popup was was hidden when an item is dragged in or out
  * fix: When clicked the application tray button, the hover background
    is not displayed

 -- Wang Zichong <wangzichong@deepin.org>  Tue, 23 Sep 2025 13:09:55 +0800

dde-shell (2.0.10) unstable; urgency=medium

  * fix: adjust notification center scrollbar position
  * fix: adjust notification center width calculation
  * fix: remove redundant focus property in notification center
  * fix: ensure panel tooltips are capitalized
  * i18n: Updates for project Deepin Desktop Environment (#1247)
  * chore: bump CMake minimum required version to 3.16

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 18 Sep 2025 20:39:39 +0800

dde-shell (2.0.9) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#1244)
  * fix: add back cache for window preview to avoid lag
  * chore: eliminate CMake configuration warnings
  * fix: add QML annotations to eliminate compilation warnings
  * fix: crash when click close on preview window in some cases
  * fix: improve task manager layout calculation
  * fix: prevent duplicate QML import paths
  * feat: add trash file drop support
  * refactor: migrate taskmanager model to the new DockItemModel
  * i18n: Updates for project Deepin Desktop Environment (#1236)

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 11 Sep 2025 21:00:13 +0800

dde-shell (2.0.8) unstable; urgency=medium

  * fix: OSD cannot displayed on top of the lock window (#1234)
  * chore: remove requestPreview from abstracttaskmanagerinterface.h
  * i18n: Updates for project Deepin Desktop Environment (#1232)
  * fix: pluginVisibleChanged signal needs to be sent when dragging the
    plugin docked to tray
  * chore: add showdesktop and windoweffect to transifex.yaml
  * i18n: Updates for project Deepin Desktop Environment (#1231)
  * chore: implement dock item menus for DockGlobalElementModel

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 28 Aug 2025 14:33:05 +0200

dde-shell (2.0.7) unstable; urgency=medium

  * Fix: missing license header in new developer document
  * Fix: fix dock window shadow animation issue
  * Chore: Re-implement the calculation method of exclusion zone (#1227)
  * Chore: optimize packaging (#1225)
  * Feat: add configurable show desktop feature
  * Feat: new dconfig option to allow disable cgroups-based app grouping
  * Fix: update building warning.

 -- zyz <zhaoyingzhen@uniontech.com>  Fri, 22 Aug 2025 09:32:54 +0800

dde-shell (2.0.6) unstable; urgency=medium

  * i18n: Translate org.deepin.ds.notificationbubble.ts in lo (#1219)
  * chore: add ar, de, lo, sq to DDEShellPackageMacros.cmake
  * i18n: Updates for project Deepin Desktop Environment (#1211)
  * fix: close tooltip before show desktop action



=== debian/control ===
Source: dde-shell
Section: DDE
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dde-application-manager-api (>= 1.2.23),
 dde-tray-loader-dev (>= 1.99.14),
 extra-cmake-modules,
 libdtk6core-bin,
 libdtk6core-dev,
 libdtk6declarative,
 libdtk6gui-dev,
 libdtk6widget-dev,
 libdtkcommon-dev,
 libgtest-dev,
 libicu-dev,
 libqt6svg6,
 libxcb-ewmh-dev,
 libxcb-icccm4-dev,
 libxcb-res0-dev,
 libxcb-util-dev,
 libxcb1-dev,
 libxtst-dev,
 libyaml-cpp-dev,
 qml6-module-qtquick-controls2-styles-chameleon,
 qt6-base-dev,
 qt6-base-dev-tools,
 qt6-declarative-dev,
 qt6-declarative-private-dev,
 qt6-l10n-tools,
 qt6-svg-dev,
 qt6-tools-dev,
 qt6-wayland (>= 6.8.0-0deepin6),
 qt6-wayland-dev (>= 6.8.0-0deepin6),
 qt6-wayland-dev-tools,
 qt6-wayland-private-dev,
 systemd,
 treeland-protocols,
 wayland-protocols,
Standards-Version: 4.6.2
Homepage: https://github.com/linuxdeepin/dde-shell

Package: libdde-shell
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: DDE Shell library
 DDE Shell is a plugin system that integrates plugins developed based on this plugin system into DDE.

Package: dde-shell
Architecture: any
Depends:
 dde-tray-loader (>= 1.99.8),
 libdde-shell (= ${binary:Version}),
 libdtk6declarative,
 libqt6sql6-sqlite,
 libqt6svg6,
 qml6-module-qt-labs-platform,
 qml6-module-qt-labs-qmlmodels,
 qml6-module-qtquick-controls2-styles-chameleon,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qt6-wayland (>= 6.8),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 dde-clipboard (<< 1:6.0.14),
Description: An wrapper for developed based on dde-shell plugin system

Package: dde-shell-example
Architecture: any
Depends:
 libdde-shell (= ${binary:Version}),
 qml6-module-qt-labs-platform,
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: DDE Shell example
 This package contains some plugins based on dde-shell plugin system.

Package: libdde-shell-dev
Architecture: any
Depends:
 libdde-shell (= ${binary:Version}),
 libdtk6core-dev,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
 ${misc:Depends},
Description: DDE Shell devel library
 DDE Shell is a plugin system that integrates plugins developed based on this plugin system into DDE.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall
export DEB_CXXFLAGS_MAINT_APPEND = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DDS_VERSION=${PACK_VER}

## dde-shell 2.0.17

=== example/lockscreen-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

ds_install_package(PACKAGE org.deepin.ds.example.lockscreen)

=== panels/dock/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

configure_file(environments.h.in environments.h @ONLY)

find_package(PkgConfig REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} COMPONENTS Core DBus Gui Qml WaylandCompositor Widgets WaylandClient)
find_package(DdeTrayLoader REQUIRED)
find_package(TreelandProtocols REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

file(
    GLOB dock_panel_sources
    constants.h
    dockabstractsettingsconfig.h
    dockdbusproxy.cpp
    dockdbusproxy.h
    dockiteminfo.cpp
    dockiteminfo.h
    dockpanel.cpp
    dockpanel.h
    docksettings.cpp
    docksettings.h
    dockhelper.h
    dockhelper.cpp
    waylanddockhelper.h
    waylanddockhelper.cpp
    loadtrayplugins.h
    loadtrayplugins.cpp
)

# Old dbus interface compatible
qt_add_dbus_adaptor(dock_panel_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/api/old/org.deepin.dde.dock1.xml
    dockdbusproxy.h
    dock::DockDBusProxy
    dockfrontadaptor
    DockFrontAdaptor
)
qt_add_dbus_adaptor(dock_panel_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/api/old/org.deepin.dde.daemon.Dock1.xml
    dockdbusproxy.h
    dock::DockDBusProxy
    dockdaemonadaptor
    DockDaemonAdaptor
)

# dock dbus api
qt_add_dbus_adaptor(dock_panel_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.ds.dock.xml
    dockpanel.h
    dock::DockPanel
    dockadaptor
    DockAdaptor
)

add_library(dockpanel SHARED
    ${dock_panel_sources}
)

qt_generate_wayland_protocol_client_sources(dockpanel
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-wallpaper-color-v1.xml
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
)

target_link_libraries(dockpanel PRIVATE
    PkgConfig::WaylandClient
    Qt${QT_VERSION_MAJOR}::WaylandClient
    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
    Qt${QT_VERSION_MAJOR}::Widgets
    dde-shell-frame
)

if (BUILD_WITH_X11)
    target_compile_definitions(dockpanel PRIVATE BUILD_WITH_X11=)
    pkg_check_modules(XCB REQUIRED IMPORTED_TARGET xcb xcb-aux xcb-res xcb-ewmh)
    target_sources(dockpanel PRIVATE
        x11dockhelper.h
        x11dockhelper.cpp
    )

    target_link_libraries(dockpanel PUBLIC
        PkgConfig::XCB
    )
endif(BUILD_WITH_X11)

ds_install_package(PACKAGE org.deepin.ds.dock TARGET dockpanel)
ds_handle_package_translation(PACKAGE org.deepin.ds.dock)

# sub plugins
add_subdirectory(showdesktop)
add_subdirectory(taskmanager)
add_subdirectory(tray)
add_subdirectory(multitaskview)

#add_subdirectory(appruntimeitem)

# dock qml element(include Dock.xx defines and DockCompositor)
file(
    GLOB plugin_sources
    constants.h
    # dockfilterproxymodel.cpp
    # dockfilterproxymodel.h
    pluginmanagerextension_p.h
    pluginmanagerextension.cpp
    pluginmanagerintegration_p.h
    pluginmanagerintegration.cpp
    dockpositioner.h
    dockpositioner.cpp
)

set_source_files_properties(DockCompositor.qml PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
)

set_source_files_properties(MenuHelper.qml PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
)

set_source_files_properties(DockPalette.qml PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
)

qt_add_qml_module(dock-plugin
    PLUGIN_TARGET dock-plugin
    URI "org.deepin.ds.dock"
    VERSION "1.0"
    SHARED
    SOURCES ${plugin_sources}
    QML_FILES DockCompositor.qml OverflowContainer.qml MenuHelper.qml DockPalette.qml
    AppletItemButton.qml
    AppletItemBackground.qml
    OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/plugins/org/deepin/ds/dock/
)

qt_generate_wayland_protocol_server_sources(dock-plugin
    FILES
        ${DDE_TRAY_LOADER_PROTOCOL}
        ${WaylandProtocols_DATADIR}/staging/fractional-scale/fractional-scale-v1.xml
)

target_link_libraries(dock-plugin PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::WaylandCompositor
PRIVATE
    PkgConfig::WaylandClient
    Qt${QT_VERSION_MAJOR}::WaylandCompositorPrivate
    Qt${QT_VERSION_MAJOR}::GuiPrivate
)

target_include_directories(dock-plugin
    PUBLIC
    $<TARGET_PROPERTY:dde-shell-frame,INTERFACE_INCLUDE_DIRECTORIES>
)

install(TARGETS dock-plugin DESTINATION "${QML_INSTALL_DIR}/org/deepin/ds/dock/")
install(DIRECTORY "${PROJECT_BINARY_DIR}/plugins/org/deepin/ds/dock/" DESTINATION "${QML_INSTALL_DIR}/org/deepin/ds/dock/")
dtk_add_config_meta_files(APPID org.deepin.ds.dock FILES dconfig/org.deepin.ds.dock.json) # compat
dtk_add_config_meta_files(APPID org.deepin.ds.dock FILES dconfig/org.deepin.ds.dock.tray.json) # compat
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES dconfig/org.deepin.ds.dock.json)
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES dconfig/org.deepin.ds.dock.tray.json)

=== tests/panels/dock/taskmanager/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

find_package(GTest REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Test)

include(GoogleTest)

add_executable(rolecombinemodel_tests
    combinemodela.cpp
    combinemodela.h
    combinemodelb.cpp
    combinemodelb.h
    rolecombinemodeltests.cpp
)

target_link_libraries(rolecombinemodel_tests
    GTest::GTest
    GTest::Main
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
    dock-taskmanager
)
target_include_directories(rolecombinemodel_tests PRIVATE
    ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager/
)

gtest_discover_tests(rolecombinemodel_tests)

add_executable(rolegroupmodel_tests
    rolegroupmodeltests.cpp
)

target_link_libraries(rolegroupmodel_tests
    GTest::GTest
    GTest::Main
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
    dock-taskmanager
)
target_include_directories(rolegroupmodel_tests PRIVATE
    ${CMAKE_SOURCE_DIR}/panels/dock/taskmanager/
)

gtest_discover_tests(rolegroupmodel_tests)

=== debian/changelog ===
dde-shell (2.0.17) unstable; urgency=medium

  * fix: use correct index when adding dock elements
  * i18n: Translate org.deepin.ds.osd.default.ts in fi (#1327)
  * fix: incorrect window state for JLCPCB
  * chore: ensure ctest can detect gtest unit tests
  * feat: ability to fine-tune cgroups-based appid detection
  * fix: skip tooltip windows in dock event filter
  * i18n: Updates for project Deepin Desktop Environment (#1322)

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 06 Nov 2025 16:14:02 +0800

dde-shell (2.0.16) unstable; urgency=medium

  * feat: implement trash empty state detection
  * feat: add camera status OSD notifications
  * i18n: Updates for project Deepin Desktop Environment (#1315)
  * fix: disable dock panel dragging when locked
  * fix: correct bubble ID handling in notification system
  * feat: set focus to first expanded notification item
  * feat: enhance window identification with ApplicationManager
  * feat: add modal property to notification setting menu
  * refactor: optimize expired notification cleanup implementation
  * Revert "feat: add trash file drop support"

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 30 Oct 2025 21:44:35 +0800

## dde-shell 2.0.19

=== shell/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Widget REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Widgets Gui WaylandClient)
find_package(TreelandProtocols REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

add_executable(dde-shell
    main.cpp
    appletloader.h
    appletloader.cpp
    shell.h
    shell.cpp
    treelandoutputwatcher.h
    treelandoutputwatcher.cpp
    dde-shell.qrc
    override_dtkdeclarative_qml.qrc
)

qt_generate_wayland_protocol_client_sources(dde-shell
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-output-manager-v1.xml
)

target_compile_definitions(dde-shell
PRIVATE
    DS_VERSION=${CMAKE_PROJECT_VERSION}
)

target_link_libraries(dde-shell PRIVATE
    dde-shell-frame
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::WaylandClient
    Dtk${DTK_VERSION_MAJOR}::Gui
    Dtk${DTK_VERSION_MAJOR}::Widget
    Qt${QT_VERSION_MAJOR}::DBus
    PkgConfig::WaylandClient
)

configure_file(${CMAKE_SOURCE_DIR}/misc/dde-shell-plugin@.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/dde-shell-plugin@.service
    @ONLY)
configure_file(${CMAKE_SOURCE_DIR}/misc/dde-shell@.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/dde-shell@.service
    @ONLY)

# debug config file
install(FILES ${CMAKE_SOURCE_DIR}/misc/deepin-debug-config/org.deepin.dde.shell.json
    DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-debug-config/deepin-debug-config.d)
install(FILES ${CMAKE_SOURCE_DIR}/misc/deepin-log-config/org.deepin.dde.shell.json
    DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-log-viewer/deepin-log.conf.d)

install(TARGETS dde-shell DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-shell@.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-shell-plugin@.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES org.deepin.dde.shell.json)

=== debian/changelog ===
dde-shell (2.0.19) unstable; urgency=medium

  * feat: enhance notification animations and visual effects

 -- zhangkun <zhangkun2@uniontech.com>  Fri, 14 Nov 2025 10:30:15 +0800

dde-shell (2.0.18) unstable; urgency=medium

  * fix: fix collapsed tray item visual index
  * fix: scale task manager preview icons for high DPI displays
  * chore: make hover preview proxy model simpler
  * i18n: Updates for project Deepin Desktop Environment (#1341)
  * fix: disable dynamic sort filter in task manager proxy model
  * feat: add plugin update to tray whitelist
  * fix: WinSCP dock icon stayed when window closed
  * fix: add exact match flag to prevent duplicate app entries
  * i18n: Translate org.deepin.ds.osd.default.ts in pl (#1335)
  * fix: update dde-shell.install for debug log configs
  * chore: adapt debugging settings function

 -- xionglinlin <xionglinlin@uniontech.com>  Thu, 13 Nov 2025 19:48:04 +0800

## dde-shell 2.0.19.2

=== shell/CMakeLists.txt ===
--- 
+++ 
@@ -65,3 +65,4 @@
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-shell@.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-shell-plugin@.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})
 dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES org.deepin.dde.shell.json)
+dtk_add_config_override_files(APPID org.deepin.dde.shell META_NAME org.deepin.dtk.preference FILES overrides/org.deepin.dtk.preference.json)

=== debian/changelog ===
dde-shell (2.0.19.2) unstable; urgency=medium

  * feat: add dock-specific tray item visibility control

 -- YeShanShan <yeshanshan@uniontech.com>  Fri, 16 Jan 2026 10:40:29 +0800

dde-shell (2.0.19.1) unstable; urgency=medium

  * fix: add command whitelist validation for notification actions
  * fix: add DTK preference override configuration

 -- YeShanShan <yeshanshan@uniontech.com>  Tue, 06 Jan 2026 10:18:57 +0800
